Search.MenuProvider = newClass(Wdgt.Menu, {
	constructor: function(menu, behaviour) {
		behaviour.name = 'provider';
		var result = this.constructor.prototype.constructor.call(this, menu, behaviour);

		this.provider = Wdgt.preferences.get('search-provider', 'yandex');
		this.provider = this.getById(this.provider);
		this.updateTab();
		
		
		var options = {
			checkTarget: false,
			preventDefault: true,
			context: this
		};
		
		var ctrl = (Wdgt.platform.name == 'opera') && (Wdgt.platform.os != 'mac');
		y5.ShortCut.down([{ctrl: ctrl, alt: true, key: y5.ShortCut.LEFT_ARROW}], this.onKeyAltLeft, document, options);
		y5.ShortCut.down([{ctrl: ctrl, alt: true, key: y5.ShortCut.RIGHT_ARROW}], this.onKeyAltRight, document, options);
		
		//y5.Events.observe('mousedown', this.onTabClick, y5.Dom.$('provider-tab'), true, this);
		y5.Events.observe('mousedown', this.onTabClick, y5.Dom.$('provider-tab'), true, this);
		
		new y5.Observer('item-click', this.onItemClick, this, true, this);
		return result;
	},
	onKeyAltLeft: function() {this.onChangeProvider('-');},
	onKeyAltRight: function() {this.onChangeProvider('+');},
	onChangeProvider: function(direction) {
		if(this.isVisible())
			return;
		var current = this.provider;
		if(current.id.indexOf('maps') == 0)
			current = this.menu[this.menu.length - 1];
						
		var next = null;
					for(var i = 0; i < this.menu.length; i++)
					if(this.menu[i] == current) {
							if(direction == '+') 
								next = this.menu[(i + 1) % this.menu.length];
							else
								next = this.menu[(i + this.menu.length - 1) % this.menu.length];
							break;
						}
					if(next == null)
						next = this.menu[0];
					
					if(next.id.indexOf('maps') == 0) {
						next = null;
						var active_map = Wdgt.preferences.get('active-map');
						var maps = this.menu[menu_searches.length - 1].menu;
						for(var i = 0; i < maps.length; i++)
							if(maps[i].id == active_map) {
								next = maps[i];
								break;
							}
						if(next == null)
							next = maps[0];
					}
					this.provider = next;
					this.updateTab();
	},

	onTabClick: function(e) {
		//e.preventDefault(); // del it
		//System.Gadget.beginTransition();
		this.visibility();
		//System.Gadget.endTransition(System.Gadget.TransitionType.morph, 1);
	},
	visibility: function(show) {
		this.constructor.prototype.visibility.call(this, show);
		this.clearSelection();
		this.closeGroups();
	},
	updateTab: function() {
		y5.Dom.$('provider-logo').style.backgroundImage = 'url(kernel/images/icons/services/' + (this.provider.icon ? this.provider.icon : 'maps.png') + ')';
		y5.Dom.$('provider-name').innerHTML = this.provider.title;
		if(this.provider.id.indexOf('maps') == 0)
			Wdgt.preferences.set('active-map', this.provider.id);
		Wdgt.preferences.set('search-provider', this.provider.id);
	},
	/* cообщения */
	onItemClick: function() {
		var active = this.getActive();
		if(typeof active.menu.menu != 'undefined')
			return;

		if(this.provider != active.menu) {
			this.provider = active.menu;
			this.updateTab();
		}
		this.hide();
		setTimeout(function(){y5.Dom.$('search-line-request').focus();}, 300);
	}
});