Search.MenuSuggestor = newClass(Wdgt.Menu, {
	constructor: function(menu, behaviour) {
		behaviour.name = 'suggestor';
		behaviour.max_height = 200;
		this.input = behaviour.input;
		this.button = behaviour.button;
		this.disable_suggestor = false;
		this.mode = '';
		this.opera = Wdgt.platform.name == 'opera';
		
		new Wdgt.ActiveButton(this.button);
		this.range = new y5.Range(this.input);
		var result = this.constructor.prototype.constructor.call(this, menu, behaviour);
		// читаем историю
		this.history = Wdgt.preferences.get('history');
		if(this.history != '')
			this.history = this.history.split(';');
		else
			this.history = [];
		
		this.requestTimer = 0;
		this.abortTimer = 0;
		this.ajax = null;
		
		this.underline = new Search.Underline(this.input);
		
		var context = this;
		/*
		this.input.onkeypress = function(e) {
			e.cancelBubble = true;
			e.preventDefault();
			e.stopPropagation();
			e.returnValue = false;

			context.onInputKeyUp.call(context, e);

			return false;
		}
		*/
		// события
		
		y5.Events.observe('keydown', this.onInputKeyDown, this.input, true, this);
		y5.Events.observe('keyup', this.onInputKeyUp, this.input, true, this);

		y5.Events.observe(Wdgt.platform.name == 'sidebar' ? 'mousedown' : 'click', this.onSearch, this.button, true, this);
		y5.ShortCut.down([{key: y5.ShortCut.ENTER}], this.onSearch, this.input, {checkTarget: false, preventDefault: true, context: this});
		var ctrl = (Wdgt.platform.name == 'opera') && (Wdgt.platform.os != 'mac');
		y5.ShortCut.down([{key: y5.ShortCut.DOWN_ARROW, alt: true, ctrl: ctrl}], this.onToggleHistory, document, {checkTarget: false, preventDefault: true, context: this});
		
		// сообщения
		new y5.Observer('item-hover', this.onItemHover, this, true, this);
		
		new y5.Observer('item-click', this.onItemClick, this, true, this);
		new y5.Observer('item-key', this.onItemKey, this, true, this);
		return result;
	},
	visibility: function(show) {
		if(!show && this.isVisible())
			this.mode = '';
		var result = this.constructor.prototype.visibility.call(this, show);
		this.underline.visibility(show);
		return result;
	},
	clearHistory: function() {
		Wdgt.preferences.set('history', '');
		this.history = [];
	},
	onToggleHistory: function() {
		this.abort();
		if(this.mode == 'suggestor') {
			this.hide();
		}
		if(this.isVisible()) {
			this.hide();
			return;
		}
		var n = this.history.length;
		if(n == 0)
			return;
		this.mode = 'history';
		var items = [];
		for(var i = 0; i < n; i++) {
			items.push({
				title: this.history[i],
				className: 'history'
			});
		}
		this.type_length = 0;
		this.create(items);
		this.show();
	},
	addToHistory: function(request) {
		request = request.replace(/\x1b/gm, ' ');
		request = request.replace(/\x1e/gm, '');
		request = y5.Strings.normalizeSpace(request);
		request = request.toLowerCase();
		if(request == '')
			return;
		for(var i = 0; i < this.history.length; i++)
			if(this.history[i] == request)
				return;
		this.history.push(request);
		while(this.history.length > 1000)
			this.history.splice(0, 1);
		this.history = this.history.sort();
		Wdgt.preferences.set('history', this.history.join(';'));
	},
	
	filteredHistory: function(part) {
		if(part == '')
			return this.history;
		part = part.toLowerCase();
		var result = [];
		for(var i = 0; i < this.history.length; i++)
			if(this.history[i].indexOf(part) == 0)
				result.push(this.history[i]);
		return result;
	},
	
	isArrowKey: function(e) {
		switch(e.keyCode) {
			case y5.ShortCut.UP_ARROW:
			case y5.ShortCut.DOWN_ARROW:
			case y5.ShortCut.LEFT_ARROW:
			case y5.ShortCut.RIGHT_ARROW:
				return true;
			break;
		}
		return false;
	},
	isDelKey: function(e) {
		return (e.keyCode == y5.ShortCut.BACKSPACE) || (e.keyCode == y5.ShortCut.DELETE);
	},
	isEnterKey: function(e) {
		return (e.keyCode == y5.ShortCut.ENTER);
	},
	isModifierKey: function(e) {
		switch(e.keyCode) {
			case y5.ShortCut.SHIFT:
			case y5.ShortCut.CTRL:
			case y5.ShortCut.ALT:
			case y5.ShortCut.CAPS_LOCK:
			case y5.ShortCut.ESC:
				return true;
			break;
		}
		return false;		
	},
	operaInputFilter: function() {
		var value = this.input.value;
		if(value != value.replace(/\x1e/gm, '')) {
			this.input.value = value.replace(/\x1e/gm, '');
		}	
	},
	/* события */
	onSearch: function() {
		if(this.isFolderActive())
			return;

		var url = this.behaviour.owner.menu_provider.provider.address;
		var request = y5.Strings.normalizeSpace(this.input.value);
		if(request == '')
			return false;
		url = url.replace('%s', encodeURIComponent(request));
		//setTimeout(function(){y5.Dom.$('search-line-request').select();}, 300);
		this.addToHistory(request);
		this.hideAllMenu();
		this.abort();			
		Wdgt.utils.openURL(url);
		this.range.select(0, this.input.value.length);
		this.input.focus();
	},
	onInputKeyDown: function(e) {
		if(this.opera) {
			var context = this;
			function filter() {context.operaInputFilter.call(context);}
			setTimeout(filter, 1);
		}
	},
	onInputKeyUp: function(e) {
		if(this.opera)
			this.operaInputFilter();
	
		if(this.isArrowKey(e) || this.isEnterKey(e) || this.isModifierKey(e))
			return;
		
		if(this.mode == 'history')
			return;
		
		this.disable_suggestor = this.isDelKey(e);
		
		this.type_length = this.input.value.length;

		var value = this.input.value;
		if(y5.Strings.normalizeSpace(value) == '') {
			clearTimeout(this.suggestTimer);
			this.abort();
			this.hide();
			return;
		}
		
		this.suggestFilter();
		
		this.mode = 'suggestor';
	},
	suggestFilter: function() {
		clearTimeout(this.suggestTimer);
		var context = this;
		function onTimeout() {context.suggest.call(context);}
		this.suggestTimer = setTimeout(onTimeout, 600);
	},
	suggest: function() {
		var value = this.input.value;
		var items = [];
		var filtered = this.filteredHistory(value);
		var n = filtered.length;
		var filtered_items = items;
		for(var i = 0; i < n; i++) {
			if((i == 6) && (n > 7)) {
				filtered_items.push({
					title: 'все мои запросы',
					className: 'show-all',
					hide_after_expand: true,
					menu: []
				});
				
				filtered_items = filtered_items[filtered_items.length - 1].menu;
			}
			filtered_items.push({
				title: filtered[i],
				className: 'history',
				//hover: hover,
				//arrow: activate,
				//action: suggest
				context: this
			});
		}
		
		if(items.length > 0) {
			this.create(items);
			this.show();
			if(!this.disable_suggestor && (Wdgt.platform.os != 'windows')) {
				this.selectFirstItem();
				this.onItemKey();
			}
		} else {
			//this.hide();
			this.menu = [];
		}
		
		this.request(value);
	},
	requestFilter: function(part) {
		clearTimeout(this.requestTimer);
		var context = this;
		function onTimeout() {context.request.call(context, part);}
		this.requestTimer = setTimeout(onTimeout, 300);
	},
	abort: function() {
		clearTimeout(this.requestTimer);
		clearTimeout(this.abortTimer);
		if(this.ajax)
			this.ajax.abort();
		this.ajax = null;
	},
	request: function(part) {
		this.abort();
			
		if(y5.Strings.normalizeSpace(part) == '')
			return;
		var context = this;
		function onAjax(request) {
			clearTimeout(this.abortTimer);
			var text = request.responseText || '["' + part + '", []]';
			context.response.call(context, text);
		}
		function abort() {context.abort.call(context);}
		this.ajax = new y5.Request.XML('http://suggest.yandex.net/suggest-ff.cgi?part=' + encodeURIComponent(part));
		this.ajax.onload = onAjax;
		this.ajax.onerror = onAjax;
		this.ajax.send();
		this.abortTimer = setTimeout(abort, 2000);
	},
	response: function(result) {
		this.ajax = null;
		if(!result) {
			return;
		} else {
			var response = null;
			var words = null, part = null;
			try {
				var s = y5.Strings.trim(result.replace(/\n+/gm, ''));
				eval('response = ' + s + ';');
				part = response[0];
				words = response[1];
			} catch(e) {
				return;
			}
						
			var n = words.length;
			if(n > 0) {
				var menu = [];
				//var active = null;
				
				if(this.isVisible()) {
					menu = this.menu;
					//var active = this.getActive();
					//if(active)
					//	active.menu.className += ' hover';
				}
				
			
				menu.push({title: 'подсказки', disable: true, className: 'suggests'});
				n = (n <= 7 ? n : 7);
				for(var i = 0; i < n; i++) {
					menu.push({
						title: words[i],
						//action: suggest,
						//hover: hover,
						//arrow: activate,
						className: 'suggest'
					});
					//if(items.length >= 12)
					//	break;
				}
				//this.hide();
				this.create(menu);
				this.show();
				this.mode = 'suggestor';
				if(!this.getActive()) {
					if(!this.disable_suggestor && (Wdgt.platform.os != 'windows')) {
						var part1 = this.input.value.toLowerCase();
						var part2 = words[0].toLowerCase();
						if (part2.length >= part1.length && part2.substr(0, part1.length) == part1) {
							this.selectFirstItem();
							this.onItemKey();
						}
					}
				}
				//if(active != null)
				//	y5.Classes.add(active.item, 'hover');
				//	//this.onItemMouseOver({target: active.item});
			} else {
				this.hide();
				this.menu = [];
			}
			
			
		}
	},
	/* cообщения */
	onItemHover: function() {
		//y5.Dom.$('search-line-request').value += '*';
	},
	isFolderActive: function() {
		var active = this.getActive();
		return !!(active && active.menu && active.menu.menu);
	},
	onItemClick: function() {
		var active = this.getActive();
		if (active && active.menu && active.menu.menu)
			return;
		this.input.value = active.menu.title;
		this.onSearch();
	},
	onItemKey: function() {
		var active = this.getActive();
		if(!(active && active.menu))
			return;
		if(typeof active.menu.menu != 'undefined')
			return;
					
		this.input.value = active.menu.title;
		this.range.select(this.type_length, this.input.value.length);
		this.underline.update();
		
		if(Wdgt.platform.name == 'opera') {
			var context = this;
			function select() {context.range.select(context.type_length, context.input.value.length);}
			setTimeout(select, 1);
		}
	}
});