Search = newClass(null, {
	name: "widget.search",
	version: 1.020004,
	clid: {status: 46964, morda: 46941},
	require: [],
	constructor: function(menu, behaviour) {
		// настроки по умолчанию
		var reduction = Wdgt.preferences.get('reduction');
		if((reduction != 'true') && (reduction != 'false'))
			Wdgt.preferences.set('reduction', 'true');
		var skin = Wdgt.preferences.get('skin');
		if(skin == '')
			Wdgt.preferences.set('skin', 'yellow-green');


		this.mode = new Search.Mode();
		//this.mode.set('skin', Wdgt.preferences.get('skin'));
		this.mode.set('mode', Wdgt.utils.isDocked() ? 'docked' : 'normal');
		

		y5.Classes.assign(document.body, 'linux', Wdgt.platform.os == 'linux');
		y5.Classes.assign(document.body, 'standalone-application', /Version\/((10.[2-9]\d)|(1[1-9].\d\d)|([2-9]\d.\d\d))/.test(navigator.userAgent));

		if(!Wdgt.utils.isYandeskInstall())
			menu_searches.splice(1, 1);


		// sidebar only
		if(Wdgt.platform.name == 'sidebar') {
			var context = this;
			function onCheckState() {context.onCheckState.call(context);}
			System.Gadget.onDock = onCheckState;
			System.Gadget.onUndock = onCheckState;
			
			this.focus = new Wdgt.Focus(Wdgt, this);
			this.focus.subscribe(window);
			this.focus.subscribe(window.document.body, true);

			new y5.Observer('focus-kill', this.onCheckState, this, true, this);
			new y5.Observer('focus-set', this.onCheckState, this, true, this);
			
		}


		this.menu_suggestor = new Search.MenuSuggestor(null, {container: normal, input: y5.Dom.$('search-line-request'), button: y5.Dom.$('search-button'), owner: this});
		this.menu_provider = new Search.MenuProvider(menu_searches, {container: normal, owner: this});
		
		
		new y5.Observer('update', this.onUpdate, this, true, this);
		new y5.Observer('menu-change-state', this.onMenuChange, this, true, this);



		
		

		
		// preferences
		if(Wdgt.platform.name == 'dashboard') {
			new Wdgt.PreferencesButton(y5.Dom.$('preferences-button'), y5.Dom.$('normal'));
			y5.Events.observe('click', this.togglePreferences, y5.Dom.$('preferences-button'), true, this);
		}
		y5.Events.observe('click', this.togglePreferences, y5.Dom.$('preferences-done'), true, this);
		y5.Events.observe('click', this.clearHistory, y5.Dom.$('preferences-clear-history'), true, this);
		y5.Events.observe('click', this.skinSelectClick, y5.Dom.$('preferences-skin-select'), true, this);
		new Wdgt.ActiveButton(y5.Dom.$('preferences-done'), y5.Dom.$('normal'));
		new Wdgt.ActiveButton(y5.Dom.$('preferences-clear-history'), y5.Dom.$('normal'));
		
	

		
		// enable preloading
		y5.Dom.$('preloading').className = 'pl';
	},
	visibility: function(show) {
	},
	clearHistory: function() {
		this.menu_suggestor.clearHistory();
	},
	onMenuChange: function(state) {
		var docked = Wdgt.utils.isDocked();
		var bottom = state.height + state.top;
		var height = (docked ? 80 : 100);
		height = (bottom < height ? height : bottom);
		var width = (docked ? 130 : 250);
		
		if(!(Wdgt.platform.name == 'sidebar' && !docked))
			Wdgt.view.setSize(width, height);
		
		if(state.visible)
			this.mode.set('menu', state.menu.behaviour.name);
		else
			this.mode.set('menu', '');

		if(Wdgt.platform.name == 'sidebar') {
			var b = document.getElementById('background');
			if(state.height == 0) {
				Wdgt.view.restoreBackground();
			}
			else {
				Wdgt.view.restoreBackground();
				if(((!docked) && (bottom > 86)) || ((docked) && (bottom > 75))) {
					var menu = state.menu.behaviour.name;
					var left, top;
					if(menu == 'suggestor')
						if(docked) {
							left = 6;
							top = 75;
							b.addImageObject('kernel/images/yellow/menu/patch-docked-suggestor.png', left, top);
						} else {
							left = 15;
							top = 86;
							b.addImageObject('kernel/images/yellow/menu/patch-normal-suggestor.png', left, top);							
						}
						
					if(menu == 'provider')
						if(docked) {
							left = 4;
							top = 25;
							b.addImageObject('kernel/images/yellow/menu/patch-docked-provider.png', left, top);
						} else {
							left = 65;
							top = 86;
							b.addImageObject('kernel/images/yellow/menu/patch-normal-provider.png', left, top);							
						}
				}
			}
		}
	},
	onCheckState: function() {
		//y5.Dom.$('search-line-request').value += '*';
		//var f = document.body.hasFocus();
		var f = this.focus.get();
		
		if(Wdgt.platform.name != 'sidebar')
			this.mode.set('mode', 'normal');
		
		if(Wdgt.platform.name == 'sidebar') {
			if(Wdgt.utils.isDocked()) {
				this.mode.set('mode', 'docked');
			} else {
				var reduction = Wdgt.preferences.get('reduction') == 'true';
				if(reduction)
					this.mode.set('mode', f ? 'normal' : 'innactive');
				else
					this.mode.set('mode', 'normal');
			}
			
			if(f) {
				if(this.mode.get('mode') == 'innactive')
					y5.Notify('menu-hide', Wdgt.Menu);
				else
					y5.Notify('force-send-change-state', Wdgt.Menu);
			} else {
				y5.Notify('menu-hide', Wdgt.Menu);
			}
		}
		
	},
	onUpdate: function() {
		y5.Classes.assign(document.body, 'update', Wdgt.update.status.update);
		function download() {
			Wdgt.utils.openURL(Wdgt.update.status.url);
			return false;
		}
		y5.Dom.$('update-button').onclick = download;
		if(y5.Dom.$('preferences')) {
			y5.Dom.$('preferences-update-link').onclick = download;
		}
	},
	togglePreferences: function() {
		if(this.mode.get('mode') != 'preferences') {
			y5.Dom.$('preferences-status').innerHTML = 'Яндекс.Поиск ' + Wdgt.update.getVersion() + '<br> &copy; 2008-' + (new Date()).getFullYear() + ' &laquo;Яндекс&raquo;';
			y5.Dom.$('preferences-update-link').onclick = function(){Wdgt.utils.openURL(Wdgt.update.status.url);return false;};
			y5.Dom.$('preferences-feedback-link').onclick = function(){Wdgt.utils.openURL('http://feedback.yandex.ru/?from=nano&subject=Виджеты');return false;};

			this.mode.set('mode', 'preferences');

			y5.Classes.add(y5.Dom.getDescendant(y5.Dom.$('preferences-skin-select'), 'div', 'skin-' + Wdgt.preferences.get('skin')), 'select');
		} else {
			Wdgt.preferences.set('skin', this.skinGetCurrent());
			this.mode.set('mode', 'normal');
		}
	},
	skinSelectClick: function(e) {
		var button = y5.Dom.getAncestor(e.target, 'div', 'skin-preview');
		if(!button)
			return;
		var container = button.parentNode;
		var selected = y5.Dom.getDescendant(container, 'div', 'select');
		y5.Classes.remove(selected, 'select');
		y5.Classes.add(button, 'select');
	},
	skinGetCurrent: function() {
		var button = y5.Dom.getDescendant(y5.Dom.$('preferences-skin-select'), 'div', 'select');
		if(y5.Classes.test(button, 'skin-yellow-green'))
			return 'yellow-green';
		if(y5.Classes.test(button, 'skin-yellow-gray'))
			return 'yellow-gray';
		if(y5.Classes.test(button, 'skin-black'))
			return 'black';
	}	
});

Wdgt.Widget = Search;